package com.awesome.screen_controller;

import android.content.BroadcastReceiver;
import android.content.Context;
import android.content.Intent;
import android.content.IntentFilter;

import io.flutter.Log;


public class ScreenBroadcastReceiver extends BroadcastReceiver {

    private Context context;
    private ScreenListener screenListener;
    private boolean isOpen = true;

    ScreenBroadcastReceiver(Context context, ScreenListener listener){
        this.context = context;
        this.screenListener = listener;
    }

    private boolean isRegisterReceiver = false;

    @Override
    public void onReceive(Context context, Intent intent) {
        String action = intent.getAction();
        if (Intent.ACTION_SCREEN_ON.equals(action)) {
            isOpen = true;
            Log.d("111", "==============11111=========");
            if(screenListener != null){
                screenListener.onScreenStateChange(true);
            }
        } else if (Intent.ACTION_SCREEN_OFF.equals(action)) {
            isOpen = false;
            Log.d("111", "===============2222=========");
            if(screenListener != null){
                screenListener.onScreenStateChange(false);
            }
        }
    }

    public void registerScreenBroadcastReceiver() {
        if (!isRegisterReceiver && context != null) {
            isRegisterReceiver = true;
            IntentFilter filter = new IntentFilter();
            filter.addAction(Intent.ACTION_SCREEN_OFF);
            filter.addAction(Intent.ACTION_SCREEN_ON);
            filter.addAction(Intent.ACTION_USER_PRESENT);
            context.registerReceiver(ScreenBroadcastReceiver.this, filter);
        }
    }

    public void unRegisterScreenBroadcastReceiver() {
        if (isRegisterReceiver && context != null) {
            isRegisterReceiver = false;
            context.unregisterReceiver(ScreenBroadcastReceiver.this);
        }
    }

    public boolean getScreenState(){
        return  isOpen;
    }


}

