import 'dart:async';
import 'dart:io';

import 'package:flutter/services.dart';

typedef void EventHandler(Object event);

class ScreenController {

  static const MethodChannel _channel = const MethodChannel('com.awesome.screen_plugin');

  static const EventChannel _status_channel =
  const EventChannel('com.awesome.listener');

  static Future<bool> isScreenOn() async {
    if(Platform.isAndroid){
      final bool isScreenOn = await _channel.invokeMethod('com.awesome.isScreenOn');
      return isScreenOn;
    }else{
      print("Cannot use this apI on non-android");
    }
    return true;
  }

  static Future<void> registerReceiver() async {
    if(!Platform.isAndroid){
      print("Cannot use this apI on non-android");
      return;
    }
    await _channel.invokeMethod('com.awesome.register');
  }

  static Future<void> unregisterReceiver() async {
    if(!Platform.isAndroid){
      print("Cannot use this apI on non-android");
      return;
    }
    await _channel.invokeMethod('com.awesome.unregister');
  }

  static statusChangedListener(EventHandler onEvent, EventHandler onError) {
    if(!Platform.isAndroid){
      print("Cannot use this apI on non-android");
      return;
    }
    _status_channel.receiveBroadcastStream().listen(onEvent, onError: onError);
  }
}
